#include <stdio.h>
#include "lo/lo.h"
//#include "portaudio.h"
#include <fstream>
#include <iostream>
using namespace std;

ofstream myfile;

int number = 0;
double startSecond;
string exitString;
lo_timetag start;
lo_timetag myTime2;


void osc_error(int num, const char *msg, const char *path)
{
    printf("liblo server error %d in path %s: %s\n", num, path, msg);
    fflush(stdout);
}

int generic_handler(const char *path, const char *types, lo_arg **argv,
					int argc, void *data, void *user_data)
{
    int i;
    printf("path: <%s>\n", path);
	//char argumentArray [argc];
	myfile << path << "\n";
	
	
	lo_timetag myTime = lo_message_get_timestamp (data);//myTime = argv[i]->t;
	double real = (lo_timetag_diff(myTime, myTime2));	
	//myfile << myTime.sec-start.sec << "\n";
	//myfile << myTime.frac << "\n";
	myfile << real << "\n";
	myTime2 = lo_message_get_timestamp (data);
	
	//myfile << real << "\n";
	printf("Difference %f\n", real);
	
	myfile << types << "\n";
	myfile << argc << "\n";
	
	for (i=0; i<argc; i++) {
	
		if(types[i] == 'f'){
		myfile << (argv[i]->f) << "\n";
		}
		if(types[i] == 'i'){
			myfile << (argv[i]->i) << "\n";
		}
	}
	myfile << "\n";
	
    for (i=0; i<argc; i++) {
		printf("arg %d '%c' ", i, types[i]);
		lo_arg_pp(lo_type(types[i]), argv[i]);
		printf("\n");
		    }
	
    printf("\n");
    fflush(stdout);
	
    return 1;
}

int main(int argc, char *argv[])
{	char c;

	lo_timetag_now(&start);
	lo_timetag_now(&myTime2);
	startSecond = (double)start.sec;
	printf("start time is this: %f\n", startSecond);

	
		myfile.open (argv[2]);
	
	lo_server_thread st = lo_server_thread_new(argv[1], osc_error);//7770
	lo_server_thread_add_method(st, NULL, NULL, generic_handler, NULL);
	lo_server_thread_start(st);
	printf("josh\n");

	do{
	getline(cin, exitString);
		sleep(2.0);//Pa_Sleep(1*1000); // sleep for 30 seconds
	}
	while(exitString.empty());
	//TO EXIT PROGRAM type any letter and then enter really quickly.  Sorry that's ghetto. 
	
	myfile.close();
	return 0;
		

	

}


	

